%OFDM modem
%Azucena Faus
%Includes Channel Distortion, uses Cyclic Prefix and Preamble to fight noise


clear all;
yy=[];
fyy=[];
fia_c=[];
frec=[];

%preamble formation
in1 =2*(floor(2*rand(1,128))) - 1;
in2 =2*(floor(2*rand(1,128))) - 1;
in_pre=in1+j*in2;
fiapre=fftshift(in_pre);
out_pre=ifft(fiapre,128);
cycpre=out_pre((length(out_pre)-31):length(out_pre));
yy=[cycpre out_pre]; %preamble added to yy along with cyclic prefix of its own

for(i=1:50)
    in1 =(floor(4*rand(1,64)) - 1.5)/1.5;
    in2 =(floor(4*rand(1,64)) - 1.5)/1.5;
    in=in1+j*in2;

    ia=zeros(1,128);
    ia(33:64)=in(1:32);
    ia(66:97)=in(33:64);
    
    %figure(1); subplot(1,2,1); grid;
    %plot(real(ia))

    fia=fftshift(ia);
    fia_c=[fia_c fia];
    figure(1); grid;
    plot(real(ia));

    out_ift=ifft(fia,128);
    figure(4); grid; plot(abs(out_ift));
    prefix=out_ift((length(out_ift)-31):(length(out_ift)));
    yy=[yy prefix out_ift];  %length of in_channel should be 160
   
end
%channel
chan=[1 0 0.2 0 0 0 j*0.1];
yyc=conv(yy,chan);
for(i=0:50)
    if(i==0)
        fr=fft(yyc((i*160+33):(i*160+33+127)),128); %take last 128 points of preamble frame
        fre=fftshift(fr);
        fchan=fre./in_pre;
    else
        fr=fft(yyc((i*160+33):(i*160+33+127)),128); %take last 128 points of every frame
        fre=fftshift(fr);
        fre=fre./fchan;
        frec=[frec fre(33:64) fre(66:97)];        
    end
end
 
ryy=real(frec);
iyy=imag(frec);

figure(100)
plot(ryy(1:length(ryy)), iyy(1:length(iyy)), 'x'); grid on;
title('Constellation at Receiver due to channel with cyclic prefix for every frame and Preamble');
axis('square');
axis([-1.5 1.5 -1.5 1.5]);

 fyy=fft(yy,8000);
% 
 figure(3); grid;
 plot(real(fia_c));
 figure(2); grid;
 plot(fftshift(20*log10(abs(fyy)))); %axis([1 length(fyy) -1 1])